=== src/sys/CMakeLists.txt ===
include_directories(${SDL_INCLUDE_DIR})
add_library(sdl_extensions_sys STATIC wizgp2x.cpp wizgp2x.h)
