=== debian/changelog ===
commander-genius (3.6.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #737587).

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 10 Dec 2025 14:46:20 +0100
