=== debian/control ===
Source: commander-genius
Section: contrib/games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat(= 13), cmake, libsdl2-dev, libsdl2-mixer-dev, libogg-dev, libvorbis-dev, libsdl2-image-dev, libsdl2-ttf-dev, libcurl4-openssl-dev
Homepage: https://clonekeenplus.sourceforge.net
Standards-Version: 4.7.2

Package: commander-genius
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: game-data-packager
Description: engine used to play the "Commander Keen" game series
 Commander-Genius aka CloneKeenPlus is an engine which interprets
 Commander Keen 1-6 (Vorticons and Galaxy Series).
 .
 You will need the original, non-distributable, game data files.
 You can install them by using the game-data-packager tool.
 .
 Commander Keen 1 and 4 are freely available.
