=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:

execute_after_dh_install:
	mv debian/commander-genius/usr/share/applications/cgenius.desktop \
	   debian/commander-genius/usr/share/applications/io.sourceforge.clonekeenplus.desktop
