=== debian/watch ===
Version: 5
Template: Github
Owner: gerstrong
Project: Commander-Genius
Repack: yes
Repacksuffix: +dfsg
Dversion-Mangle: auto
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@SEMANTIC_VERSION@
